
# names.dep

# This is a little overkill, but it's the easiest way... Others leave ridiculous heaps of files everywhere, or are complex and
# very tricky to get to work. This is fast and easy therefore it stays.
#
# Basically, it reads in a file with a little info about each sprite. It then generates rules to generate them, allocating a
# sprite number, and automatically adding options for animation if required. It adds the dependancy "stuff.inc" to every file.
# It also cleans up all temporary files it creates.
#
# The format for names.tbl (the input file) is:
#   <name> <modes> <frames> [ <dependancies> ... ]
# If a single asteririsk (*) is specified as the first dependancy animation mode is initiated. Basically the pov files used are:
# <name>.<mode>.<frame>.pov for a simple file, or <name>.<mode>.pov for an animation.
#
# Phew. Documetation wears me out. Goodnight.

BEGIN {
  this = 0;
  n = "";
}

/^[a-z]+ [0-9]+ [0-9]+/ {
  for(a=0; a<$2; a++) for(b=0; b<$3; b++) {
    base = $1 "." a "." b;

    dep = "";
    for(i=4; i<=NF; i++)
      if($(i) != "*") dep = dep " " $(i) ".inc";

    if($4 == "*") {
      sprname = this".spr";
      povname = $1"."a".pov";
      tganame = $1"."a"."b".tga";
      povmaskname = $1"."a".mask.pov";
      tgamaskname = $1"."a"."b".mask.tga";
      anim = " +k"b * (1 / $3);
    } else {
      sprname = this".spr";
      povname = $1"."a"."b".pov";
      tganame = $1"."a"."b".tga";
      povmaskname = $1"."a"."b".mask.pov";
      tgamaskname = $1"."a"."b".mask.tga";
      anim = "";
    }
    
    print(sprname": "povname""dep);
    print("\t$(POVRAY) sprite.ini $(POVOPTS) +w${spr_w} +h${spr_h} +i"povname" +o"tganame anim);
    print("\t(cat mask.pov; cat "povname") > "povmaskname);
    print("\t$(POVRAY) sprite.ini $(POVOPTS) +w${spr_w} +h${spr_h} +i"povmaskname" +o"tgamaskname anim);
    print("\t$(TGA2SPR) "tganame" "sprname" "tgamaskname);
    print("\trm -f "tganame" "povmaskname" "tgamaskname);
    
    n = n " " this;

    this++;
  }
}

END {
  print("NUMBERS =" n);
}
