/*C* $Id: putspr.cc,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#include <stdio.h>
#include <stdlib.h>
#include "vga++/sprite.h"
#include "util.h"

int main(int argc, char** argv)
{
 if(argc != 4) Fatal("Syntax: putspr <spr file> <sprites file> <index>\n");
 int index = strtol(argv[3], NULL, 10);
 Sprite spr;

 if(!spr.load(argv[1])) Fatal("Cannot load %s\n", argv[1]);

 FILE* fp = fopen(argv[2], "r+");
 if(!fp) Fatal("Cannot open %s\n", argv[2]);

 int w, h;
 fread(&w, sizeof(w), 1, fp);
 fread(&h, sizeof(h), 1, fp);
 if(ferror(fp)) Fatal("Error reading %s\n", argv[2]);
 if(w != spr.getWidth() || h != spr.getHeight())
  Fatal("%s's (%dx%d) dimensions do not match %s's (%dx%d)\n", argv[1], spr.getWidth(), spr.getHeight(), argv[2], w, h);

 fseek(fp, w*h*index, SEEK_CUR);
 if(ferror(fp) || !spr.write(fp)) Fatal("Error writing to %s\n", argv[2]);
 fclose(fp);

 return EXIT_SUCCESS;
}

