/*C* $Id: animation.h,v 1.4 1997/08/12 17:36:46 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#ifndef animation_h
#define animation_h

#include <stdio.h>
#include <stdlib.h>

#include "src/pos.h"

class Animation
{
private:
 int modes, frames, repeats;
 int** data;
 int mode, frame, repeat;
 int w, h;
 class Sprite** sprites;
 bool mySprites;

public:
 Animation(int _modes, int _frames, int _repeats, Sprite** _sprites = NULL, int** _data = NULL);
 ~Animation() {}

 int getFrame() { return frame; }
 int getMode() { return mode; }
 int getRepeats() { return repeats; }

 int setFrame(int _frame) { return frame = _frame; }
 int setMode(int _mode) { return mode = _mode; }
 int setRepeats(int _repeats) { return repeats = _repeats; }

 void draw(class VgaContext* vc, int x, int y, bool advance = true);
 void blur(class BlurryVga* vc, int x, int y, bool advance = true);
 void blur(class BlurryVga* vc, Pos& pos, bool advance = true) { blur(vc, pos.x, pos.y, advance); }
 void keep(class BlurryVga* vc, int x, int y, bool advance = true);

 bool load(class File* f);
 bool load(const char* filename);

 void advanceFrame();
 void advanceSubFrame();

 int getWidth() { return w; }
 int getHeight() { return h; }
 int getFrames() { return frames; }
};

#endif
