/*C* $Id: background.cc,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#include <stdio.h>
#include <stdlib.h>
#include "src/background.h"
#include "util/error.h"
#include "util/file.h"
#include "util/util.h"

Background::Background()
 : VgaContext()
{
 setVirtual();
};

bool Background::load(const char *fname)
{
 // open the pipe
 GzipPipe f(fname, "r");
 if(f == NULL)
  {
   setError("cannot unzip %s: %y", fname);
   return false;
  }

 // read + check the header
 int w, h;
 f.read(&w, sizeof(w)); f.read(&h, sizeof(h));
 if(f.error())
  {
   setError("cannot read from %s: %y", fname);
   return false;
  }
 if(w != vgaW || h != vgaH)
  {
   setError("background %s is wrong size", fname);
   return false;
  }

 // read the data
 char data[vgaW * vgaH]; // temporary buffer to be drawn on the VgaContext
 if(f.read(data, vgaW * vgaH) != 1)
  {
   setError("cannot read from %s: %y", fname);
   return false;
  }
 putOnScreen(data); // draw it on the context

 if(f.close())
  {
   setError("cannot close %s", fname);
   return false;
  }
 return true;
}

