/*C* $Id: colorbar.cc,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#include "src/background.h"
#include "src/colorbar.h"
#include "src/data.h"
#include "src/hatspr.h"
#include "src/palette.h"
#include "src/screen.h"
#include "util/util.h"
#include "vga++/keycodes.h"
#include "vga++/keys.h"
#include "vga++/vga++blur.h"

ColorBar::ColorBar(int X, int Y, int W, int H)
{
 x = X; y = Y; w = W; h = H;
 cur = 0;
}

ColorBar::~ColorBar()
{
}

void ColorBar::update()
{
 screen->restore(x, y, w, h);
 for(int i = 0; i < 256; i++)
  {
   if(i == cur) screen->line(x, y + i, x + w - 1, y + i, makeColor(5, 5, 5));
   screen->line(x + 2, y + i, x + w - 3, y + i, i);
  }
 screen->box(x, y + 256, w, h - 256, cur);
 screen->update(x, y, w, h);
}

void ColorBar::edit()
{
#define r ((*pal)[cur][0])
#define g ((*pal)[cur][1])
#define b ((*pal)[cur][2])
 bool quit = false;
 keyboard->setMode(0);
 while(!quit)
  {
   int ex = x + w + 10;
   int ey = y;
   screen->box(ex, ey, 8 * 4, 8 * 3, 0);
   char s[64];
   sprintf(s, "R %2X", r); screen->write(ex, ey, s); ey += 8;
   sprintf(s, "G %2X", g); screen->write(ex, ey, s); ey += 8;
   sprintf(s, "B %2X", b); screen->write(ex, ey, s); ey += 8;
   screen->update();
   if(keyboard->update())
    {
     KP_KEYPAD7 if(r > 0x00) r--;
     KP_KEYPAD9 if(r < 0x3F) r++;
     KP_KEYPAD4 if(g > 0x00) g--;
     KP_KEYPAD6 if(g < 0x3F) g++;
     KP_KEYPAD1 if(b > 0x00) b--;
     KP_KEYPAD3 if(b < 0x3F) b++;
     KP_Q quit = true;
    }
  }
 pal->Set();
}


