/*C* $Id: fruit.cc,v 1.3 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#include "./data.h"
#include "./fruit.h"
#include "./globals.h"
#include "./names.h"
#include "./screen.h"
#include "./sprites.h"
#include "vga++/sprite.h"
#include "vga++/vga++blur.h"

Fruit::Fruit()
{
 dir = None;
 q = 0;
}

bool Fruit::move()
{
 if(++q > sprW)
  {
   q -= sprW;
   pos.x += xInc[dir];
   pos.y += yInc[dir];
   return true;
  }
 return false;
}

void Fruit::draw()
{
 Pos screenPos = pos.fromLevel() + Pos(xInc[dir], yInc[dir]) * q;
 (*sprites)[SPRITE_FRUIT[type][0]]->blur(screen, screenPos.x, screenPos.y);
}

void Fruit::reset()
{
 dir = None;
 q = 0;
}
