/*C* $Id: game.h,v 1.4 1997/08/13 15:44:59 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#ifndef src_game_h
#define src_game_h

#include "src/dir.h"
#include "src/ghost.h"
#include "src/pos.h"
#include "util/collection.h"

#include <stdlib.h>
#include <sys/time.h>

class Game
{
public:
 Game();
 ~Game();
 
 void setup();

 bool playerCanMove(Dir dir);
 bool ghostCanMove(int i, Dir dir);
 bool fruitCanMove(Dir dir);
 void drawScoreBox();
 void kill();
 void draw();

 void moveGhosts();
 void checkInput();
 void movePlayer();
 void moveFruit();
 void mainLoop();

 bool play();
 bool play(const char* filename);
 bool play(const class Level* _level);
 bool play(class LevelMode* _levelMode);

private:
 class GlueTextManager* gtm;
 Pos base, scorePos, lifePos;
 class Level* level;
 class Player* player;
 class Fruit* fruit;
 bool fruitActive;
 Dir fruitDir;
 Collection<Pos>* fruitStarts;
 bool quit;
 Collection<Ghost>* ghosts;
 int power, ghostScore;
 class LevelMode* levelMode;
 class SpeedControl *playerSpeed, *ghostSpeed, *ghostScaredSpeed, *ghostEyesSpeed, *fruitSpeed;
};

extern Game* game;

#endif
