/*C* $Id: ghost.h,v 1.3 1997/08/12 17:51:05 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#ifndef src_ghost_h
#define src_ghost_h

#include "src/dir.h"
#include "src/globals.h"
#include "src/pos.h"

class Ghost
{
public:
 Ghost(int _x, int _y, int _defaultSprite);

 enum { Alive, Scared, Dead } state;
 static int flash;

 void move(Dir _dir) { dir = _dir; Moving = true; q = 0; }
 bool move();

 void restart();
 void turnBack();

 void draw();
 
 void pellet() { if(state != Dead) state = Scared; }
 void pelletEnd() { if(state != Dead) state = Alive; }

 // get variables

 Dir  getDir() { return dir; }
 Pos& getPos() { return pos; }
 Pos  getScreenPos() { return pos.fromLevel() + Pos(xInc[dir], yInc[dir]) * q; }
 operator Dir () { return dir; }

 const int X() { return pos.x; }
 const int Y() { return pos.y; }
 const int hX() { return pos.x*sprW + q*xInc[dir]; }
 const int hY() { return pos.y*sprH + q*yInc[dir]; }

private:
 Pos pos, start;
 int q;
 int defaultSprite;
 
 Dir dir;
 
 bool Moving;
};

#endif
