/*C* $Id: level.h,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#include <stdio.h>
#include "src/ghost.h"
#include "src/globals.h"
#include "src/pos.h"
#include "util/collection.h"

class Level
{
private:
 char data[lvlW][lvlH];
 
public:
 int dots;

 Level();
 ~Level() {}
 
 Level& operator=(const Level& level);
 
 bool load(class File* f);
 bool load(const char *filename);

 void getGhosts(Collection<class Ghost>* Ghosts);

 bool save(FILE *fp);
 
 void draw(int x, int y);
 void draw();

 void setSquare(int x, int y, int type);
 int getSquare(int x, int y) { return data[x][y]; }
 int getSquare(Pos& pos) { return data[pos.x][pos.y]; }
 
 void clear(int x, int y);
 void clear(const Pos& p) { clear(p.x, p.y); }
 void clear();

 bool checkLevel();

 Pos find(int block);
};
