/*C* $Id: menu.h,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#ifndef MENU_H
#define MENU_H

#include "util/collection.h"

class MenuItemType
{
private:
 char* name;
 bool (*callback)();
public:
 MenuItemType(const char* Name, bool (*Callback)());
 ~MenuItemType();
 operator const char* () { return name; }
 bool operator () () { return callback(); }
};

class MenuType
{
private:
 Collection<MenuItemType>* items;
 void (*callback)();
public:
 MenuType(void (*Callback)());
 ~MenuType();
 void Add(const char* Name, bool (*Callback)());
 void Draw(int x, int y, int w, int h, int i, class VgaContext* bk);
 void operator () (int x, int y, int w, int h, class VgaContext* bk);
};

#endif
