/*C* $Id: player.cc,v 1.4 1997/08/12 17:36:41 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#include "src/animation.h"
#include "src/data.h"
#include "src/player.h"
#include "src/screen.h"
#include "util/util.h"
#include "vga++/vga++blur.h"

Player::Player()
{
 reset();
}

void Player::reset()
{
 score = 0;
 lives = 3;
 setPos(startPos);
}

void Player::move(Dir _dir)
{
 animPlayer->setMode(dir = _dir);
 dirPending = None;
 Moving = true;
}

void Player::setPos(int NewX, int NewY)
{
 pos.x = NewX;
 pos.y = NewY;
 q = 0;
 dirPending = None;
 animPlayer->setMode(dir = Right);
 Moving = false;
}

bool Player::move()
{
 if(!Moving) return false;
 if(++q >= sprW)
  {
   q = 0;
   wrap(pos.x, xInc[dir], lvlW + 1);
   wrap(pos.y, yInc[dir], lvlH + 1);
   return true;
  }
 return false;
}

void Player::turnBack()
{
 if(q != 0)
  {
   wrap(pos.x, xInc[dir], lvlW + 1);
   wrap(pos.y, yInc[dir], lvlH + 1);
   q = sprW-q;
  }
 animPlayer->setMode(dir = behindOf[dir]);
 Moving = true;
}

void Player::draw()
{
 Pos screenPos(pos.x * sprW + q * xInc[dir] + xOff, pos.y * sprH + q * yInc[dir] + yOff);
 if(screenPos.x <= -sprW) screenPos.x += vgaW; else if((screenPos.x + sprW) >= vgaW) screenPos.x -= vgaW;
 if(screenPos.y <= -sprH) screenPos.y += vgaH; else if((screenPos.y + sprH) >= vgaH) screenPos.y -= vgaH;
 animPlayer->blur(screen, screenPos.x, screenPos.y, false);
 if(screenPos.x < 0 || screenPos.y < 0)
  {
   if(screenPos.x < 0) animPlayer->blur(screen, screenPos.x + vgaW, screenPos.y, false);
   if(screenPos.y < 0) animPlayer->blur(screen, screenPos.x, screenPos.y + vgaH, false);
   if(screenPos.x < 0 && screenPos.y < 0) animPlayer->blur(screen, screenPos.x + vgaW, screenPos.y + vgaH, false);
  }
}
