/*C* $Id: player.h,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#include "src/dir.h"
#include "src/globals.h"
#include "src/pos.h"

class Player
{
private:
 Pos pos;
 int q;
 Dir dir;
 Dir dirPending;
 bool Moving;

public:
 int score, lives;
 Pos startPos;

 PlayerType();

 void move(Dir _dir);

 void reset();
 
 inline int X() { return pos.x; }
 inline int Y() { return pos.y; }
 inline int hX() { return pos.x*sprW + q*xInc[dir]; }
 inline int hY() { return pos.y*sprH + q*yInc[dir]; }
 
 // get variables

 Dir  getDir() { return dir; }
 Dir  getDirPending() { return dirPending; }
 int  getDisplacement() { return q; }
 int  getLives() { return lives; }
 Pos& getPos() { return pos; }
 Pos  getScreenPos() { return pos.fromLevel() + Pos(xInc[dir], yInc[dir]) * q; }
 int  getScore() { return score; }
 bool isMoving() { return Moving; }

 // set variables

 void setDirPending(Dir _dir) { dirPending = _dir; }
 void setPos(int NewX, int NewY);
 void setPos(Pos& pos) { setPos(pos.x, pos.y); }

 bool move();
 
 bool onSquare() { return q? false : true; }

 void draw();

 void stop() { Moving = false; }

 void turnBack();
};


