/*C* $Id: sprites.h,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#ifndef sprites_h
#define sprites_h

#include <stdio.h>
#include "util/collection.h"
#include "vga++/sprite.h"

class Sprites
{
public:
 Sprites();
 ~Sprites();
 class Sprite* operator [] (int i) { return (*data)[i]; }
 int read(class File* f, int w, int h);
 int load(class File* f);
 bool load(const char* filename);
 bool write(class File* f);
 bool save(class File* f);
 bool save(const char* filename);
 int getCount() { return count; }
 class Sprite** getData() { return data->getData(); }

 void compile();
 void compileAndForget();

private:
 Collection<Sprite>* data;
 int count;
};

#endif
