/*C* $Id: spriteslide.cc,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#include "./background.h"
#include "./blocks.h"
#include "./data.h"
#include "./globals.h"
#include "./screen.h"
#include "./spriteslide.h"
#include "./sprites.h"
#include "util/util.h"
#include "vga++/sprite.h"
#include "vga++/vga++blur.h"
#include "vga++/vga++.h"

SpriteSlide::SpriteSlide(int _count, class Sprite** _sprites)
{
 count = _count;
 data = new Sprite*[count];
 for(int i=0; i<count; i++)
  data[i] = _sprites[i];
 sel = 0;
 w = data[0]->getWidth();
 h = data[0]->getHeight();
}

SpriteSlide::SpriteSlide(int _count, int* _sprites)
{
 count = _count;
 data = new Sprite*[count];
 for(int i=0; i<count; i++)
  data[i] = (*sprites)[_sprites[i]];
 sel = 0;
 w = sprW; h = sprH;
}

SpriteSlide::~SpriteSlide()
{
 delete data;
}

int SpriteSlide::operator ++ (int)
{
 wrap(sel, +1, count);
 return sel;
}

int SpriteSlide::operator -- (int)
{
 wrap(sel, -1, count); 
 return sel;
}

void SpriteSlide::update(int i)
{
 data[(sel+i)%count]->restoreAndDrawAndUpdate(screen, vgaW-w, i*h);
}

void SpriteSlide::draw()
{
 screen->restore(vgaW-w, 0, w, vgaH);
 for(int i=0; i<(int)(vgaH / h); i++)
  data[(sel+i)%count]->draw(screen, vgaW-w, i*h);
 screen->update(vgaW-w, 0, w, vgaH);
}
