/*C* $Id: collection.cc,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#include "util/collection.h"

#include <stdlib.h>

CollectionBase::CollectionBase(int _space, int _delta)
{
 ok = true;
 items = 0;
 space = _space;
 delta = _delta;
 data = 0;
 if((data = (void**)malloc(dataSize())) == NULL)
  ok = false;
}

CollectionBase::~CollectionBase()
{
 free(data);
}

bool CollectionBase::add(void* object)
{
 if(!ok) return false;
 if(items == space)
  if(!grow()) return ok = false;
 data[items] = object;
 items++;
 return true;
}

void CollectionBase::removeAll()
{
 if(!ok) return;
 for(int n=0; n<items; n++)
  remove(n);
 items = 0;
}

void CollectionBase::pack()
{
 int n=0;
 for(int i=0; i<items; i++)
  if(data[i] != 0)
   data[n++] = data[i];
 items = n;
}

bool CollectionBase::grow()
{
 space += delta;
 return ok = ((data = (void**)realloc(data, dataSize())) != 0)? true : false;
}
