
#ifndef COLLECTION_H
#define COLLECTION_H

#include <stdlib.h>

#define foreach(c,i) for(int i=0; i<(int)(c); i++)
#define every(c,op) for(int i=0; i<(int)(c); i++) (c)[i]->op;

class CollectionBase
{
public:
 bool ok;
 CollectionBase(int _space = 16, int _delta = 16);
 ~CollectionBase();
 inline void* operator [] (int n) { return data[n]; }
 inline void* at(int n) { return data[n]; }
 inline operator int () { return items; }
 inline int getItems() { return items; }
 bool add(void* object);
 inline void remove(int index) { data[index] = 0; }
 void removeAll();
 void pack();
 inline void** getData() { return data; }

protected:
 void** data;
 int items, space, delta;
 size_t dataSize() { return sizeof(void*) * space; }
 bool grow();
};

template <class T> class Collection : public CollectionBase
{
public:
 Collection(int _space = 16, int _delta = 16) : CollectionBase(_space, _delta) {}
 inline T* operator [] (int n) { return (T*)CollectionBase::at(n); }
 inline T* at(int n) { return (T*)CollectionBase::at(n); }

 bool add(T* object) { return CollectionBase::add((void*)object); }

 void del(int index)
  {
   delete (T*)at(index);
   remove(index);
  }
 
 bool delAll()
  {
   if(!ok) return false;
   int n;
   for(n=0; n<items; n++)
    delete data[n];
   items = 0;
   return true;
  }

 T** getData() { return (T**) CollectionBase::getData(); }
};

#endif

