/*C* $Id: file.h,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#ifndef file_h
#define file_h

#include <stdio.h>
#include <sys/types.h>

class File
{
public:
 File();
 File(const char* filename, const char* mode);
 virtual ~File();

 operator FILE* () { return fp; }
 operator bool () { return fp? true : false; }
 File& operator = (FILE* _fp) { fp = _fp; return *this; }

 virtual int close();
 FILE* open(const char* filename, const char* mode);

 size_t read(void* data, size_t size, size_t count = 1) { return fread(data, size, count, fp); }
 size_t write(void* data, size_t size, size_t count = 1) { return fwrite(data, size, count, fp); }

 int getChar() { return getc(fp); }
 int unGetChar(int c) { return ungetc(c, fp); }

 int scanf(const char* format, ...);

 int eof() { return feof(fp); }
 int error() { return ferror(fp); }

protected:
 FILE* fp;
};

class Pipe : public File
{
public:
 Pipe();
 Pipe(const char* filename, const char* mode);
 virtual ~Pipe();
 virtual int close();
 FILE* open(const char* filename, const char* mode);
};

class GzipPipe : public Pipe
{
public:
 GzipPipe() : Pipe() {}
 GzipPipe(const char* filename, const char* mode);
 FILE* open(const char* filename, const char* mode);
};

#endif
