/*C* $Id: util.h,v 1.2 1997/08/11 19:21:31 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#ifndef util_h
#define util_h

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

//-----------------------------------------------------------------------------
template <class T> inline void Swap(T& a, T& b)
/*
 * Swaps two variables, of any type.
 */
{
 T c = a;
 a = b;
 b = c;
}

//-----------------------------------------------------------------------------
#define rInt(a) (rand() / (RAND_MAX / (a) - 1))

//-----------------------------------------------------------------------------
template <class T> inline T wrap(T& value, T inc, T limit)
{
 while(value < -inc) value += limit;
 value = (value + inc) % limit;
 return value;
}

//-----------------------------------------------------------------------------
inline char* newString(const char* s)
/*
 * Create a new copy of a string
 */
{
 return strcpy(new char[strlen(s)+1], s);
}

//-----------------------------------------------------------------------------
inline bool gzFilename(const char* s)
{
 return ((strlen(s) > 3) && !strcmp(s + strlen(s) - 3, ".gz"))? true : false;
}

//-----------------------------------------------------------------------------
inline unsigned long long GetTicks()
{
 timeval TimeVal;
 gettimeofday(&TimeVal, NULL);
 return TimeVal.tv_sec * 1000 + TimeVal.tv_usec / 1000;
}

//-----------------------------------------------------------------------------
#define DPRINTF(format, args...) fprintf(stderr, format, ## args)
/*
 * This is nasty and GNUy, but hey - why not?
 */

//-----------------------------------------------------------------------------
inline int makeColor(int r, int g, int b) { return (r*6 + g)*6 + b + 1; }

//-----------------------------------------------------------------------------
extern void Fatal(const char *format = "Fatal error\n", ...);
extern void nonFatal(const char* format = "Non-fatal error\n", ...);

#endif
