
#include <vgakeyboard.h>

#include "vga++/keys.h"

bool KeyboardType::initialised = false;
char KeyboardType::keys[256];
char KeyboardType::kmode = 0;
bool KeyboardType::anyPressed = false;

void khandle(int scancode, int newstate)
{
#define kset(a) k |= (a)
#define kclear(a) k &= ~(a)
 char& k = KeyboardType::keys[scancode];
 char& m = KeyboardType::kmode;
 if(newstate)
  {
   if(k & kmask_waitrelease) return;
   if(!(k & kmask_down) || (m & kmode_repeat))
    kset(kmask_pressed | kmask_down);
   else
    kclear(kmask_pressed);
  }
 else
  kclear(kmask_down | kmask_waitrelease);
 KeyboardType::anyPressed = true;
}

KeyboardType::KeyboardType()
{
}

KeyboardType::~KeyboardType()
{
 if(initialised) keyboard_close();
 initialised = false;
}

bool KeyboardType::init()
{
 if(initialised) return false;
 if(keyboard_init() == -1) return false;
 keyboard_seteventhandler(khandle);
 return initialised = true;
}

void KeyboardType::close()
{
 keyboard_close();
}

void KeyboardType::waitRelease()
{
 for(int i=0; i<256; i++)
  {
   if(keys[i] & kmask_down) keys[i] |= kmask_waitrelease;
   keys[i] &= ~(kmask_pressed | kmask_down);
  }
}

bool KeyboardType::pressed(int code)
{
 bool ret = (keys[code] & kmask_pressed)? true : false;
 keys[code] &= ~kmask_pressed;
 return ret;
}

bool KeyboardType::update()
{
 anyPressed = false;
 keyboard_update();
 return pressed;
}

void KeyboardType::clear()
{
 keyboard_clearstate(); 
}
