/*C* $Id: keys.h,v 1.2 1997/08/11 19:22:18 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#ifndef vgaxxkeys_h
#define vgaxxkeys_h

//#include <vgakeyboard.h>

const int kmode_repeat       = 0x01;

const char kmask_down        = 0x01;
const char kmask_pressed     = 0x02;
const char kmask_waitrelease = 0x04;

class KeyboardType
{
private:
 static bool initialised;
 static char keys[256];
 static char kmode;
 static bool anyPressed;

 friend void khandle(int, int);

public:
 KeyboardType();
 ~KeyboardType();

 bool init();
 void close();

 char operator [] (int code) { return keys[code]; }

 bool down(int code) { return (keys[code] & kmask_down)? true : false; }
 bool pressed(int code);

 bool update();
 void clear();
 void get();

 char setMode(char KMode) { return kmode = KMode; }
 char getMode() { return kmode; }

 void waitRelease();
};

#endif
