/*C* $Id: sprite.h,v 1.2 1997/08/11 19:22:18 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#ifndef vgaxx_sprite_h
#define vgaxx_sprite_h

#include <stdio.h>

class Sprite
{
public:
 bool ok;
   
 Sprite();
 Sprite(int _w, int _h, FILE *fp);
 Sprite(int _w, int _h, int Initial = 0);
 Sprite(int _w, int _h, const char* _data);
 void alloc(char**& data);
 void alloc();
 void free();
 void freeCompiled();
 ~Sprite();

 int getWidth() { return w; }
 int getHeight() { return h; }

 void draw(class VgaContext* vc, int x, int y, struct ClippedCoords* cc = NULL);
 void blur(class BlurryVga* vc, int x, int y);
 void keep(class BlurryVga* vc, int x, int y);
 void drawAndUpdate(class BlurryVga* vc, int x, int y);
 void restoreAndDrawAndUpdate(class BlurryVga* vc, int x, int y);

 char getPixel(int x, int y) { return data[y][x]; } 
 char setPixel(int x, int y, int c);

 bool read(FILE* fp, int _w, int _h);
 bool write(FILE* fp);
 bool load(const char* filename);
 bool save(const char* filename);

 void flipH();
 void flipV();
 void rotate();

 void compile(); 
 void compileAndForget();

private:
 char** data;
 char* compiledData;
 int w, h;
};


#endif


