/*C* $Id: vga++blur.cc,v 1.2 1997/08/11 19:22:18 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#include "util/util.h"
#include "vga++blur.h"

//-----------------------------------------------------------------------------
BlurryVga::BlurryVga()
{
 blurs = new Collection<BlurBox>(32, 32);
 oldBlurs = new Collection<BlurBox>(32, 32);
 blurZone = new VgaContext();
 blurZone->setVirtual();
}

//-----------------------------------------------------------------------------
BlurryVga::~BlurryVga()
{
 delete blurZone;
 delete blurs;
 delete oldBlurs;
}

//-----------------------------------------------------------------------------
void BlurryVga::update()
{
 copyScreen(physicalContext);
 copyScreen(*blurZone);
}

//-----------------------------------------------------------------------------
void BlurryVga::update(int x, int y, int w, int h)
{
 copyBoxToContext(physicalContext, x, y, w, h);
}

//-----------------------------------------------------------------------------
void BlurryVga::blur()
{
 // first we copy the blurs, new and old to the physical screen
 int maxBlurs = (int)*blurs >? (int)*oldBlurs;

 // this may seem a little odd, but trust me :)
 for(int i=0; i<maxBlurs; i++)
  {
   if(i<*blurs) (*(*blurs)[i])(this, &physicalContext);
   if(i<*oldBlurs) (*(*oldBlurs)[i])(this, &physicalContext);
  }

 // then we restore all the blurs from the blurzone
 for(int i=0; i<*blurs; i++)
  (*(*blurs)[i])(blurZone, this);
 
 // then get rid of the old blurs
 oldBlurs->delAll();
 Swap(oldBlurs, blurs);
}
