/*C* $Id: vga++blur.h,v 1.2 1997/08/11 19:22:18 james Exp $
 *
 * Hatman - The Game of Kings
 * Copyright (C) 1997 James Pharaoh & Timothy Fisken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *C*/

#ifndef vgaxx_blur_h
#define vgaxx_blur_h

#include <stdio.h>
#include "vga++/vga++.h"

class BlurBox
{
private:
 int x, y, w, h;
public:
 BlurBox(int X, int Y, int W, int H)
  { x = X; y = Y; w = W; h = H; }
 ~BlurBox() {}
 void operator()(VgaContext* src, VgaContext* dst)
  { dst->copyBoxFromContext(*src, x, y, w, h); }
};

class BlurryVga : public Vga
{
public:
 BlurryVga();
 ~BlurryVga();

 void initMode() { Vga::initMode(false); }

 void putBoxMaskAndBlur(int x, int y, int w, int h, const char* dp)
  { select(); gl_putboxmask(x, y, w, h, (char*) dp); blur(x, y, w, h); }
 void putBoxMaskCompiledAndBlur(int x, int y, int w, int h, const char* dp)
  { select(); gl_putboxmaskcompiled(x, y, w, h, (char*) dp); blur(x, y, w, h); }
   
 void blur(int x, int y, int w, int h)
  { blurs->add(new BlurBox(x, y, w, h)); }
 void keep(int x, int y, int w, int h)
  { blurZone->copyBoxFromContext(context, x, y, w, h); oldBlurs->add(new BlurBox(x, y, w, h)); }

 void restore(int x, int y, int w, int h)
  { copyBoxFromContext(*blurZone, x, y, w, h); }

 void update();
 void update(int x, int y, int w, int h); 
 void blur();

private:
 Collection<BlurBox> *blurs, *oldBlurs;
 VgaContext* blurZone;
};

#endif
